
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>13.2. [R5.03.08] : Integration of nonlinear viscoplastic material models in STAT_NON_LINE &#8212; Code-Aster v14 0.1 documentation</title>
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/app.css" type="text/css" />
    <link rel="stylesheet" type="text/css" href="../../_static/graphviz.css" />
    <link rel="stylesheet" type="text/css" href="../../_static/code_aster.css" />
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script async="async" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.7/latest.js?config=TeX-AMS-MML_HTMLorMML"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="13.3. [R5.03.09] : One-dimensional nonlinear material models" href="r5.03.09.html" />
    <link rel="prev" title="13.1. R5.01.01 : Modal solvers and solving generalized eigenvalue problems (GEP)" href="r5.01.01.html" />

<script type="text/javascript" src="../../_static/sidebar.js"></script>

<link rel="stylesheet" href="https://use.typekit.net/isi7ftn.css">
<script>try{Typekit.load({ async: true });}catch(e){}</script>
<script type="text/javascript" src="../../_static/copybutton.js"></script>


  </head><body>
<div class="topbar">
  <!--
  <a class="brand" title="Documentation Home" href="../../index.html">
    <span id="logotext">LSST Science Pipelines</span>
  </a>
  -->
  <ul>
    <li><a href="https://www.code-aster.org/V2/spip.php?rubrique19">Code Aster PDF Docs</a></li>
  </ul>
</div>

<div class="related">
    <h3>Navigation</h3>
    <ul>
      <li class="right">
	<a href="r5.03.09.html" title="13.3. [R5.03.09] : One-dimensional nonlinear material models">
	  next &raquo;
	</a>
      </li>
      <li class="right">
	<a href="r5.01.01.html" title="13.1. R5.01.01 : Modal solvers and solving generalized eigenvalue problems (GEP)">
	  &laquo; previous
	</a>
	 |
      </li>
      <li>
	<a href="../../index.html">Code-Aster v14 0.1 documentation</a>
	 &#187;
      </li>
      <li><a href="r5_toc.html" accesskey="U"><span class="section-number">13. </span><strong>R5</strong> : Special analysis methods</a> &#187;</li>
      
      <li><span class="section-number">13.2. </span><strong>[R5.03.08]</strong> : Integration of nonlinear viscoplastic material models in <code class="docutils literal notranslate"><span class="pre">STAT_NON_LINE</span></code></li> 
    </ul>
</div>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="r5-03-08-integration-of-nonlinear-viscoplastic-material-models-in-stat-non-line">
<span id="r5-03-08"></span><span id="index-0"></span><h1><span class="section-number">13.2. </span><strong>[R5.03.08]</strong> : Integration of nonlinear viscoplastic material models in <code class="docutils literal notranslate"><span class="pre">STAT_NON_LINE</span></code><a class="headerlink" href="#r5-03-08-integration-of-nonlinear-viscoplastic-material-models-in-stat-non-line" title="Permalink to this headline">¶</a></h1>
<p>This document the ingredients necessary for the implementation of viscoplastic material models
in the non-linear algorithm <span class="red">STAT_NON_LINE</span> <span class="xref std std-ref">[R5.03.01]</span>. The input data of all
viscoplastic models in <code class="docutils literal notranslate"><span class="pre">Code_Aster</span></code> generally have the same form. Only the method of introducing the
viscous strain rate function varies.  The strain rate function is input with various keywords which
allow the user to choose the desired constitutive model.</p>
<p>These quantities are calculated by a semi-implicit or implicit integration method. From the initial
state, or from the preceding moment of computation, one computes the stress field resulting from an
increment of strain.</p>
<div class="section" id="introduction">
<span id="r5-03-08-1"></span><h2><span class="section-number">13.2.1. </span>Introduction<a class="headerlink" href="#introduction" title="Permalink to this headline">¶</a></h2>
<p>Here we describe the implementation of the Lemaitre model of non-linear viscoplasticity, which reduces to
the Norton model for particular values of the parameters.</p>
<p>A variant (depending on the neutron fluence) of the Lemaître model has been added, with a view to modeling
nuclear fuel assemblies (keyword <span class="blue">LEMAITRE_IRRA</span>). This model has an additional inelastic strain:
the strain magnification.</p>
<p>A viscoplastic model with threshold has been added. This is a material whose behavior is purely elastic
up to a threshold beyond which the model becomes a particular case of Lemaître model (<span class="blue">LEMA_SEUIL</span>).</p>
<p>Finally, a viscoplastic model with creep depending on the logarithmic strain rate was implemented. It is
accessible by the keyword <span class="blue">VISC_IRRA_LOG</span>.</p>
<p>For each of these models, it is assumed that the material is isotropic (except for the strain
magnification, which is uniaxial). They can be used in 3D, in plane strain (<span class="blue">D_PLAN</span>) and in
axisymmetric mode (<span class="blue">AXIS</span>).</p>
<p>We present in this document the constitutive equations of the models and their implementation in
<code class="docutils literal notranslate"><span class="pre">Code_Aster</span></code>.</p>
</div>
<div class="section" id="basic-principle-and-assumptions">
<span id="r5-03-08-2"></span><h2><span class="section-number">13.2.2. </span>Basic principle and assumptions<a class="headerlink" href="#basic-principle-and-assumptions" title="Permalink to this headline">¶</a></h2>
<p>We assume of the small deformations and decompose the strain tensor into an elastic part, a thermal part,
an inelastic part (known), and a viscous part. The equations are then:</p>
<div class="math notranslate nohighlight">
\[\begin{split}&amp; \boldsymbol{\varepsilon}_{\text{tot}} = \boldsymbol{\varepsilon}_e + \boldsymbol{\varepsilon}_{th} +
   \boldsymbol{\varepsilon}_a + \boldsymbol{\varepsilon}_v \\
&amp; \boldsymbol{\sigma} = \mathbb{A}(T) \boldsymbol{\varepsilon}_e \\
&amp; \dot{\boldsymbol{\varepsilon}}_v = g(\sigma_{\text{eq}}, \lambda , T)
    \frac{3}{2} \frac{\tilde{\boldsymbol{\sigma}}}{\sigma_{\text{eq}}}\end{split}\]</div>
<p>with</p>
<ul>
<li><p><span class="math notranslate nohighlight">\(\lambda\)</span> : cumulated viscous strain</p>
<div class="math notranslate nohighlight">
\[\dot{\lambda} = \sqrt{\frac{2}{3}\dot{\boldsymbol{\varepsilon}}_v : \dot{\boldsymbol{\varepsilon}}_v}\]</div>
</li>
<li><p><span class="math notranslate nohighlight">\(\tilde{\boldsymbol{\sigma}}\)</span> : stress deviator</p>
<div class="math notranslate nohighlight">
\[\tilde{\boldsymbol{\sigma}} = \boldsymbol{\sigma} - \frac{1}{3} \text{Tr}(\boldsymbol{\sigma}) \mathbf{I}\]</div>
</li>
<li><p><span class="math notranslate nohighlight">\(\sigma_{\text{eq}}\)</span>: equivalent stress</p>
<div class="math notranslate nohighlight">
\[\sigma_{\text{eq}} = \sqrt{\frac{3}{2} \tilde{\boldsymbol{\sigma}}: \tilde{\boldsymbol{\sigma}}}\]</div>
</li>
<li><p><span class="math notranslate nohighlight">\(\mathbb{A}(T)\)</span> : elasticity tensor</p></li>
</ul>
</div>
<div class="section" id="nature-of-the-function-g-for-each-of-the-models">
<span id="r5-03-08-3"></span><h2><span class="section-number">13.2.3. </span>Nature of the function <span class="math notranslate nohighlight">\(g\)</span> for each of the models<a class="headerlink" href="#nature-of-the-function-g-for-each-of-the-models" title="Permalink to this headline">¶</a></h2>
<div class="section" id="lemaitre-model">
<span id="r5-03-08-3-1"></span><h3><span class="section-number">13.2.3.1. </span><span class="blue">LEMAITRE</span> model<a class="headerlink" href="#lemaitre-model" title="Permalink to this headline">¶</a></h3>
<p>In this case, <span class="math notranslate nohighlight">\(g\)</span> is expressed explicitly (<span class="math notranslate nohighlight">\(\sigma\)</span> is a scalar) as:</p>
<div class="math notranslate nohighlight">
\[g(\sigma, \lambda, T) = \left(\frac{1}{K} \frac{\sigma}{\lambda^{1/m}} \right)^n
\quad \text{with} \quad
\frac{1}{K} \ge 0, \quad \frac{1}{m} \ge 0, \quad n &gt; 0\]</div>
<p>The material data are those provided under the keyword factors: <span class="blue">LEMAITRE</span> or : <span class="blue">LEMAITRE_FO</span> of the
operator <span class="red">DEFI_MATERIAU</span>.</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">LEMAITRE</span> <span class="o">=</span> <span class="n">_F</span><span class="p">(</span><span class="n">N</span> <span class="o">=</span> <span class="n">n</span><span class="p">,</span>
              <span class="n">UN_SUR_K</span> <span class="o">=</span> <span class="mi">1</span><span class="o">/</span><span class="n">K</span><span class="p">,</span>
              <span class="n">UN_SUR_M</span> <span class="o">=</span> <span class="mi">1</span><span class="o">/</span><span class="n">m</span><span class="p">)</span>
</pre></div>
</div>
<p>The Young’s modulus <span class="math notranslate nohighlight">\(E\)</span> and the Poisson’s ratio <span class="math notranslate nohighlight">\(\nu\)</span> are those provided under the keyword factors
<span class="blue">ELAS</span> or <span class="blue">ELAS_FO</span>.</p>
</div>
<div class="section" id="fluence-dependent-lemaitre-model-lemaitre-irra">
<span id="r5-03-08-3-2"></span><h3><span class="section-number">13.2.3.2. </span>Fluence-dependent <span class="blue">LEMAITRE</span> model (<span class="blue">LEMAITRE_IRRA</span>)<a class="headerlink" href="#fluence-dependent-lemaitre-model-lemaitre-irra" title="Permalink to this headline">¶</a></h3>
<p>This section describes the fluence-dependence (and its processing) of the viscoplastic model of J. Lemaître,
introduced for the modeling of fuel assemblies and applicable to 2D and 3D elements and to <span class="blue">TUYAU</span>
(<span class="gray">PIPE</span>) elements, under the keyword <span class="blue">LEMAITRE_IRRA</span>.</p>
<div class="section" id="model-formulation">
<span id="r5-03-08-3-2-1"></span><h4><span class="section-number">13.2.3.2.1. </span>Model formulation<a class="headerlink" href="#model-formulation" title="Permalink to this headline">¶</a></h4>
<p>The equations are as follows:</p>
<div class="math notranslate nohighlight">
\[\begin{split}&amp; \dot{\boldsymbol{\varepsilon}}_v = \frac{3}{2} \dot{p} \frac{\tilde{\boldsymbol{\sigma}}}{\sigma_{\text{eq}}} \\
&amp; \dot{p} = \left[\frac{\sigma_{\text{eq}}}{p^{1/m}}\right]^ n
            \left(\frac{1}{K}\frac{\varphi}{\varphi_0}+ L \right)^\beta
            \exp\left[-\frac{Q}{R(T+T_0)}\right] \\
&amp; \dot{[\mathbb{A}^{-1}(T) \boldsymbol{\sigma}]}= \dot{\boldsymbol{\varepsilon}}_{\text{tot}} -
    \dot{\boldsymbol{\varepsilon}}_v - \dot{\boldsymbol{\varepsilon}}_g - \dot{\boldsymbol{\varepsilon}}_{th}\end{split}\]</div>
<p>with <span class="math notranslate nohighlight">\(T_0\)</span> = 273.15 C, <span class="math notranslate nohighlight">\(n &gt; 0\)</span>, <span class="math notranslate nohighlight">\(1/K \ge 0\)</span>, <span class="math notranslate nohighlight">\(1/m \ge 0\)</span>, <span class="math notranslate nohighlight">\(\varphi_0 &gt; 0\)</span>,
<span class="math notranslate nohighlight">\(Q/R \ge 0\)</span>, <span class="math notranslate nohighlight">\(L \ge 0\)</span>, <span class="math notranslate nohighlight">\(\beta\)</span> any real.</p>
<p>The coefficients are provided under the keywords <span class="blue">LEMAITRE_IRRA</span> and <span class="blue">ELAS</span> of <span class="red">DEFI_MATERIAU</span> and
<span class="math notranslate nohighlight">\(\varphi\)</span> is the neutron flux (quotient of the fluence increment, defined by the keyword <span class="blue">AFFE_VARC</span> of
<span class="red">AFFE_MATERIAU</span>, per increment of time).</p>
<p>The magnification model is:</p>
<div class="math notranslate nohighlight">
\[\boldsymbol{\varepsilon}_g(t) = f(T, \varphi_t)\boldsymbol{\varepsilon}_g^0\]</div>
<p>where <span class="math notranslate nohighlight">\(\varepsilon_g^0\)</span> is the uniaxial strain unit in a reference coordinate <span class="math notranslate nohighlight">\(R_1\)</span> given by the
user using the keyword <span class="blue">MASSIF</span> (see <span class="xref std std-ref">[U4.42.01]</span> and <a class="reference internal" href="../user/u4.43.01.html#u4-43-01"><span class="std std-ref">[U4.43.01]</span></a>) and
<span class="math notranslate nohighlight">\(f(T, \varphi_t)\)</span> is also a function defined by the user in <span class="red">DEFI_MATERIAU</span>
(<a class="reference internal" href="../user/u4.43.01.html#u4-43-01"><span class="std std-ref">[U4.43.01]</span></a>).</p>
<div class="admonition-remarks admonition">
<p class="admonition-title">Remarks</p>
<p>The fluence, time and flux <span class="math notranslate nohighlight">\(\varphi_0\)</span> must be expressed in units such as the ratio
<span class="math notranslate nohighlight">\(\varphi/\varphi_0\)</span> is dimensionless. <span class="math notranslate nohighlight">\(Q/R\)</span> is in Kelvin. <span class="math notranslate nohighlight">\(T\)</span> is in C.</p>
</div>
</div>
<div class="section" id="treatment-of-fluence-dependence">
<span id="r5-03-08-3-2-2"></span><h4><span class="section-number">13.2.3.2.2. </span>Treatment of fluence-dependence<a class="headerlink" href="#treatment-of-fluence-dependence" title="Permalink to this headline">¶</a></h4>
<p>The model described above corresponds to a normal Lemaître model, defined by the three coefficients
<span class="math notranslate nohighlight">\(n, 1/K^{'}\)</span>, and <span class="math notranslate nohighlight">\(1/m\)</span> with:</p>
<div class="math notranslate nohighlight">
\[\frac{1}{K^{'}} = \left(\frac{1}{K} \frac{\varphi}{\varphi_0} + L \right)^{\beta/n}
   \exp\left(-\frac{Q}{nR (T + T_0)}\right)\]</div>
<p>So just calculate <span class="math notranslate nohighlight">\(1/K^{'}\)</span> and provide that data to the calculation instead of <span class="math notranslate nohighlight">\(1/K\)</span>.</p>
<p>In addition, in the computation of the elastic stress, one adds to the inelastic strains (zero by default) the
strain magnification expressed above, after having made the change between the local coordinate system and the
<span class="math notranslate nohighlight">\(R_1\)</span> coordinate system.</p>
</div>
</div>
<div class="section" id="lema-seuil-model">
<span id="r5-03-08-3-3"></span><h3><span class="section-number">13.2.3.3. </span><span class="blue">LEMA_SEUIL</span> model<a class="headerlink" href="#lema-seuil-model" title="Permalink to this headline">¶</a></h3>
<p>For this model, <span class="math notranslate nohighlight">\(g\)</span> is also expressed explicitly (since it is a special case of the LEMAITRE model
presented above).  If we define</p>
<div class="math notranslate nohighlight">
\[D = \frac{1}{S} \int_0^t \sigma_{\text{eq}}(\tau) d\tau\]</div>
<p>then the model behaves as follows:</p>
<div class="math notranslate nohighlight">
\[\begin{split}&amp; \text{If} \quad D \le 1 \quad \text{then} \quad g(\sigma, \lambda, T) = 0 (\text{purely elastic behavior}) \\
&amp; \text{If} \quad D &gt; 1 \quad \text{then} \quad g(\sigma, \lambda, T) = A \left(\frac{2}{\sqrt{3}}\sigma\right)
    \varphi \quad \text{with} \quad  A \ge 0, \varphi \ge 0\end{split}\]</div>
<p>The material data to be input by the user must be provided under the keyword <span class="blue">LEMA_SEUIL</span> or
<span class="blue">LEMA_SEUIL_FO</span> of operator <span class="red">DEFI_MATERIAU</span>:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">LEMA_SEUIL</span> <span class="o">=</span> <span class="n">_F</span><span class="p">(</span><span class="n">A</span> <span class="o">=</span> <span class="n">A</span><span class="p">,</span> <span class="n">S</span> <span class="o">=</span> <span class="n">S</span><span class="p">)</span>
</pre></div>
</div>
<p>As for the parameter <span class="math notranslate nohighlight">\(\varphi\)</span>, it is about the neutron flux which bombards the material (quotient of the
increment of fluence, defined by the keyword <span class="blue">AFFE_VARC</span> of <span class="red">AFFE_MATERIAU</span>, by the increment of time).</p>
<p>The Young modulus <span class="math notranslate nohighlight">\(E\)</span> and the Poisson’s ratio <span class="math notranslate nohighlight">\(\nu\)</span> are those provided under the keyword factors
<span class="blue">ELAS</span> or <span class="blue">ELAS_FO</span>.</p>
</div>
<div class="section" id="visc-irra-log-model">
<span id="r5-03-08-3-4"></span><h3><span class="section-number">13.2.3.4. </span><span class="blue">VISC_IRRA_LOG</span> model<a class="headerlink" href="#visc-irra-log-model" title="Permalink to this headline">¶</a></h3>
<p>For this model, <span class="math notranslate nohighlight">\(g\)</span> is not expressed explicitly. The behavior is represented by an one-dimensional creep
test, at constant stress, which involves the time elapsed since the instant when the stress is applied. The model
is defined by four functions <span class="math notranslate nohighlight">\(f_1, g_1, f_2, g_2\)</span> describing the evolution of the viscous strain over time:</p>
<div class="math notranslate nohighlight" id="equation-eq-r5-03-08-3-4-1">
<span class="eqno">(13.2.1)<a class="headerlink" href="#equation-eq-r5-03-08-3-4-1" title="Permalink to this equation">¶</a></span>\[\varepsilon_v = \lambda = f_1(t) g_1(\sigma, T) + f_2(t) g_2(\sigma, T)\]</div>
<p>The function <span class="math notranslate nohighlight">\(g\)</span> is then calculated numerically by eliminating the time <span class="math notranslate nohighlight">\(t\)</span> as follows:</p>
<ol class="arabic">
<li><p>for a given triplet <span class="math notranslate nohighlight">\((\sigma, \lambda, T)\)</span>, one solves in <span class="math notranslate nohighlight">\(t\)</span> the equation <a class="reference internal" href="#equation-eq-r5-03-08-3-4-1">(13.2.1)</a> by
the Newton method (see <a class="footnote-reference brackets" href="#bib2" id="id1">2</a>). We find an approximation of the solution <span class="math notranslate nohighlight">\(t(\sigma, \lambda, T )\)</span>.</p></li>
<li><p>we obtain the value of the function <span class="math notranslate nohighlight">\(g(\sigma, \lambda, T)\)</span> by differentiating with respect to time
the equation <a class="reference internal" href="#equation-eq-r5-03-08-3-4-1">(13.2.1)</a> (see <a class="footnote-reference brackets" href="#bib1" id="id2">1</a>):</p>
<div class="math notranslate nohighlight">
\[\dot{\varepsilon}_v = \dot{\lambda} = g(\sigma, \lambda, T) =
    f_1'(t) g_1(\sigma, T) + f_2'(t) g_2(\sigma, T)\]</div>
<p>and by substituting in this new equation the value of <span class="math notranslate nohighlight">\(t(\sigma, \lambda, T)\)</span> found previously. We
find the following uniaxial formulation:</p>
<div class="math notranslate nohighlight">
\[\dot{\varepsilon}_v = \dot{\lambda} = g(\sigma, \lambda, T) =
    f_1'(t(\sigma, \lambda, T)) g_1(\sigma, T) + f_2'(t(\sigma, \lambda, T)) g_2(\sigma, T )\]</div>
</li>
</ol>
<p>The form of the four functions <span class="math notranslate nohighlight">\(f_1, g_1, f_2, g_2\)</span> is predefined and the user only introduces a few
parameters in the command file.</p>
<p>For <span class="blue">VISC_IRRA_LOG</span>, we have:</p>
<div class="math notranslate nohighlight">
\[\begin{split}&amp; f_1(t) = \ln(1 + \omega \varphi t ) \\
&amp; g_1(\sigma, T) = A \sigma \exp\left(-\frac{Q}{T}\right) \\
&amp; f_2(t) = \varphi t \\
&amp; g_2(\sigma, T) = B \sigma \exp\left(-\frac{Q}{T}\right)\end{split}\]</div>
<p>The parameter <span class="math notranslate nohighlight">\(\varphi\)</span> is the neutron flux. It is must be indicated under the keyword factor
<span class="blue">AFFE_VARC</span> via the command variable <span class="blue">IRRA</span>.</p>
<p>The parameters <span class="math notranslate nohighlight">\(A, B, \omega\)</span> and <span class="math notranslate nohighlight">\(Q\)</span> are those provided under the keyword factor <span class="blue">VISC_IRRA_LOG</span>
of operator <span class="red">DEFI_MATERIAU</span>.</p>
<p>Note that for all functions, <span class="math notranslate nohighlight">\(t\)</span> is expressed in hours, <span class="math notranslate nohighlight">\(T\)</span> is expressed in C, <span class="math notranslate nohighlight">\(\sigma\)</span> is
expressed in MPa.</p>
<p>It is thus necessary to provide coherent data with these units in the command file and in the mesh file. i</p>
<p>The Young modulus <span class="math notranslate nohighlight">\(E\)</span> and the Poisson’s ratio <span class="math notranslate nohighlight">\(\nu\)</span> are those provided under the keyword factors
<span class="blue">ELAS</span> or <span class="blue">ELAS_FO</span>.</p>
</div>
</div>
<div class="section" id="integration-of-the-constitutive-relation">
<span id="r5-03-08-4"></span><h2><span class="section-number">13.2.4. </span>Integration of the constitutive relation<a class="headerlink" href="#integration-of-the-constitutive-relation" title="Permalink to this headline">¶</a></h2>
<div class="section" id="establishment-of-the-scalar-equation-for-the-implicit-scheme-and-with-constant-elastic-coefficients">
<span id="r5-03-08-4-1"></span><h3><span class="section-number">13.2.4.1. </span>Establishment of the scalar equation for the implicit scheme and with constant elastic coefficients<a class="headerlink" href="#establishment-of-the-scalar-equation-for-the-implicit-scheme-and-with-constant-elastic-coefficients" title="Permalink to this headline">¶</a></h3>
<p>We denote by <span class="math notranslate nohighlight">\(\boldsymbol{\varepsilon}_{\text{tot}}\)</span> the total strain at time <span class="math notranslate nohighlight">\(t +\Delta t\)</span> and by
<span class="math notranslate nohighlight">\(\Delta \boldsymbol{\varepsilon}_{\text{tot}}\)</span> the increment of the total strain during the current time
step.</p>
<p>We call <span class="math notranslate nohighlight">\(\boldsymbol{\varepsilon}_o\)</span> the strain at time <span class="math notranslate nohighlight">\(t +\Delta t\)</span> resulting from thermal expansion
and inelastic strains (among which possibly appear the magnification strains, cf <a class="reference internal" href="#r5-03-08-3-2"><span class="std std-numref">Section 13.2.3.2</span></a>). So
we have :</p>
<div class="math notranslate nohighlight">
\[\Delta \boldsymbol{\varepsilon}_o =
  [ \alpha(t+\Delta t) (T(t+\Delta t) - T_{\text{ref}}) - \alpha(t)(T(t) - T_{\text{ref}})] \mathbf{I}_3 +
  \boldsymbol{\varepsilon}_a (t+\Delta t) - \boldsymbol{\varepsilon}_a(t)\]</div>
<p>where <span class="math notranslate nohighlight">\(\mathbf{I}_3\)</span> is the identity tensor of order 2 in dimension 3.</p>
<p>We set <span class="math notranslate nohighlight">\(\Delta\boldsymbol{\varepsilon} = \Delta\boldsymbol{\varepsilon_{\text{tot}}} - \Delta \boldsymbol{\varepsilon}_o\)</span>.</p>
<p>As we suppose here that <span class="math notranslate nohighlight">\(\mu\)</span> is constant, we have the following relation between the deviators of
<span class="math notranslate nohighlight">\(\Delta \boldsymbol{\sigma}\)</span> and <span class="math notranslate nohighlight">\(\Delta \boldsymbol{\varepsilon}\)</span> :</p>
<div class="math notranslate nohighlight" id="equation-eq-r5-03-08-4-1-1">
<span class="eqno">(13.2.2)<a class="headerlink" href="#equation-eq-r5-03-08-4-1-1" title="Permalink to this equation">¶</a></span>\[\Delta \tilde{\boldsymbol{\sigma}} = 2\mu (\Delta\tilde{\boldsymbol{\varepsilon}} -
    \Delta\boldsymbol{\varepsilon}_v\]</div>
<p>However, the flow rule is written, implicitly:</p>
<div class="math notranslate nohighlight" id="equation-eq-r5-03-08-4-1-2">
<span class="eqno">(13.2.3)<a class="headerlink" href="#equation-eq-r5-03-08-4-1-2" title="Permalink to this equation">¶</a></span>\[\frac{\Delta \boldsymbol{\varepsilon}_v}{\Delta t} = \frac{3}{2} g(\sigma_{\text{eq}}, \lambda^{-} +
    (\Delta \boldsymbol{\varepsilon}_v)_{\text{eq}}, T)
    \frac{\tilde{\boldsymbol{\sigma}}}{\boldsymbol{\sigma}_{\text{eq}}}\]</div>
<p>We therefore have, by eliminating <span class="math notranslate nohighlight">\(\Delta \boldsymbol{\varepsilon}_v\)</span> between <a class="reference internal" href="#equation-eq-r5-03-08-4-1-1">(13.2.2)</a> and
<a class="reference internal" href="#equation-eq-r5-03-08-4-1-2">(13.2.3)</a>:</p>
<div class="math notranslate nohighlight" id="equation-eq-r5-03-08-4-1-3">
<span class="eqno">(13.2.4)<a class="headerlink" href="#equation-eq-r5-03-08-4-1-3" title="Permalink to this equation">¶</a></span>\[\begin{split}&amp; 2\mu \Delta \tilde{\boldsymbol{\varepsilon}} = \Delta \tilde{\boldsymbol{\sigma}} +
  3\mu\Delta t  g(\sigma_{\text{eq}}, \lambda^{-} + (\Delta \boldsymbol{\varepsilon}_v)_{\text{eq}}, T)
  \frac{\tilde{\boldsymbol{\sigma}}}{\sigma_{\text{eq}}} \\
&amp; (\tilde{\boldsymbol{\sigma}}^{-} + 2\mu\Delta\tilde{\boldsymbol{\varepsilon}}) =
  \left(1 + 3\mu\Delta t \frac{g(\sigma_{\text{eq}}, \lambda^{-} +
       (\Delta \boldsymbol{\varepsilon}_v)_{\text{eq}}, T)}{\sigma_{\text{eq}}}\right)
  \tilde{\boldsymbol{\sigma}}\end{split}\]</div>
<p>By posing <span class="math notranslate nohighlight">\(\tilde{\boldsymbol{\sigma}}^e = \tilde{\boldsymbol{\sigma}}^{-} + 2\mu\Delta\tilde{\boldsymbol{\varepsilon}}\)</span>, we therefore have:</p>
<div class="math notranslate nohighlight" id="equation-eq-r5-03-08-4-1-4">
<span class="eqno">(13.2.5)<a class="headerlink" href="#equation-eq-r5-03-08-4-1-4" title="Permalink to this equation">¶</a></span>\[\sigma_{\text{eq}}^e = 3\mu \Delta t g(\sigma_{\text{eq}}, \lambda^{-} +
   ( \Delta \boldsymbol{\varepsilon}_v )_{\text{eq}}, T) + \sigma_{\text{eq}}\]</div>
<p>However, one has according to <a class="reference internal" href="#equation-eq-r5-03-08-4-1-2">(13.2.3)</a>:</p>
<div class="math notranslate nohighlight">
\[(\Delta \boldsymbol{\varepsilon}_v)_{\text{eq}} = \Delta t  g (\sigma_{\text{eq}},
   \lambda^{-} + (\Delta \boldsymbol{\varepsilon}_v)_{\text{eq}}, T)\]</div>
<p>From where :</p>
<div class="math notranslate nohighlight">
\[\sigma_{\text{eq}}^e = 3\mu (\Delta \boldsymbol{\varepsilon}_v)_{\text{eq}} +
  \sigma_{\text{eq}}(\Delta\boldsymbol{\varepsilon}_v)_{\text{eq}} =
  \frac{1}{3\mu} (\sigma_{\text{eq}}^e - \sigma_{\text{eq}})\]</div>
<p>By substituting this last expression in <a class="reference internal" href="#equation-eq-r5-03-08-4-1-4">(13.2.5)</a>, one has:</p>
<div class="math notranslate nohighlight">
\[\sigma_{\text{eq}}^e = 3\mu \Delta t  g(\sigma_{\text{eq}}, \lambda^{-} +
   \frac{1}{3\mu} (\sigma_{\text{eq}}^e-\sigma_{\text{eq}}), T) + \sigma_{\text{eq}}\]</div>
<p>If we set <span class="math notranslate nohighlight">\(\sigma_{\text{eq}}^e, \lambda^{-}, T\)</span> and <span class="math notranslate nohighlight">\(\Delta t\)</span> as known:</p>
<div class="math notranslate nohighlight">
\[f(x) = 3\mu\Delta t \, g(x, \lambda^{-} + \frac{1}{3} \mu(\sigma_{\text{eq}}^e - x), T) +
   x - \sigma_{\text{eq}}^e\]</div>
<p>we can then calculate the quantity
<span class="math notranslate nohighlight">\(\sigma_{\text{eq}} = (\boldsymbol{\sigma}^{-} + \Delta\boldsymbol{\sigma})_{\text{eq}}\)</span> as being the
solution of the scalar equation: <span class="math notranslate nohighlight">\(f(x) = 0\)</span> where <span class="math notranslate nohighlight">\(x = \sigma_{\text{eq}}\)</span> is convention adopted for the following paragraphs.</p>
<p>In the case of a Lemaître model with threshold, <span class="blue">LEMA_IRRA_SEUIL</span>, the preceding equations are
useful only once the threshold has been crossed. Indeed, below the threshold, the behavior is elastic.</p>
<p>We discretize the threshold implicitly:</p>
<div class="math notranslate nohighlight">
\[D(\boldsymbol{\sigma}^{-} + \Delta \boldsymbol{\sigma}) =
  \frac{1}{S} \int_0^t(\boldsymbol{\sigma}^{-} + \Delta \boldsymbol{\sigma})_{\text{eq}}(\tau) d\tau\]</div>
<p>In the same way as for the integration of the elastoplastic constitutive laws of von Mises, one then distinguishes
two cases.</p>
<ul class="simple">
<li><p><span class="math notranslate nohighlight">\(D(\boldsymbol{\sigma}^{-} + \Delta \boldsymbol{\sigma}) \le 1\)</span> then
<span class="math notranslate nohighlight">\(g(\boldsymbol{\sigma}^{-} + \Delta \boldsymbol{\sigma}, \lambda, T) = 0\)</span>.</p></li>
<li><p><span class="math notranslate nohighlight">\(D(\boldsymbol{\sigma}^{-} + \Delta \boldsymbol{\sigma}) &gt; 1\)</span> then
<span class="math notranslate nohighlight">\(g(\boldsymbol{\sigma}^{-} + \Delta \boldsymbol{\sigma}, \lambda, T) = A \left(\frac{2}{\sqrt{3}}\sigma_{\text{eq}}\right) \varphi\)</span></p></li>
</ul>
<p>This results from the above equation:</p>
<div class="math notranslate nohighlight">
\[g(\boldsymbol{\sigma}^{-} + \Delta \boldsymbol{\sigma}, \lambda, T ) \ne
  A \left(\frac{2}{\sqrt{3}} \sigma_{\text{eq}}\right) \varphi
\quad \implies \quad D(\boldsymbol{\sigma}^{-} +\Delta \boldsymbol{\sigma}) \le 1\]</div>
<p>Or <span class="math notranslate nohighlight">\(g\)</span> can only take the value <span class="math notranslate nohighlight">\(0\)</span> or <span class="math notranslate nohighlight">\(A \left(\frac{2}{\sqrt{3}}\sigma_{\text{eq}}\right)\varphi\)</span>
therefore</p>
<div class="math notranslate nohighlight">
\[g(\boldsymbol{\sigma}^{-} + \Delta \boldsymbol{\sigma}, \lambda, T ) \ne
  A \left(\frac{2}{\sqrt{3}} \sigma_{\text{eq}}\right) \varphi
\quad \implies \quad D(\boldsymbol{\sigma}^{-} + \Delta \boldsymbol{\sigma}) \le 1
\quad \text{and} \quad \Delta\boldsymbol{\sigma} = A \Delta \boldsymbol{\varepsilon}\]</div>
<p>Alternatively, if</p>
<div class="math notranslate nohighlight">
\[ \begin{align}\begin{aligned}g(\boldsymbol{\sigma}^{-} + \Delta \boldsymbol{\sigma}, \lambda, T ) =
  A \left(\frac{2}{\sqrt{3}} \sigma_{\text{eq}}\right) \varphi\\\quad \text{then} \quad D(\boldsymbol{\sigma}^{-} + A \boldsymbol{\varepsilon}) &gt; 1\end{aligned}\end{align} \]</div>
<p>The threshold criterion can thus be written</p>
<div class="math notranslate nohighlight">
\[D(\boldsymbol{\sigma}^{-} + A \Delta \boldsymbol{\varepsilon}) &gt; 1\]</div>
<p>Or</p>
<div class="math notranslate nohighlight">
\[D(\boldsymbol{\sigma}^{-} + A \Delta \boldsymbol{\varepsilon}) =
  \frac{1}{S} \int_0^t (\boldsymbol{\sigma}^{-} + A \Delta \boldsymbol{\varepsilon})_{\text{eq}}(\tau) d\tau\]</div>
<p>By discretizing the time, we then have:</p>
<div class="math notranslate nohighlight">
\[D(\boldsymbol{\sigma}^{-} + A \Delta \boldsymbol{\varepsilon}) =
 \frac{1}{S} \int_0^{t^{-}} (\boldsymbol{\sigma}^{-} + A \Delta \boldsymbol{\varepsilon})_{\text{eq}}(\tau) d\tau +
 \frac{1}{S} \int_{t^{-}}^t (\boldsymbol{\sigma}^{-} + A \Delta \boldsymbol{\varepsilon})_{\text{eq}}(\tau) d\tau\]</div>
<div class="math notranslate nohighlight">
\[D(\boldsymbol{\sigma}^{-} + A \Delta \boldsymbol{\varepsilon}) =
 \frac{1}{S} \left(D^{-}S + \frac{\sigma_{\text{eq}}^{-} + (\boldsymbol{\sigma}^{-} +
     A \Delta \boldsymbol{\varepsilon})_{\text{eq}}}{2}(t - t^{-})\right)\]</div>
</div>
<div class="section" id="solution-of-the-scalar-equation-principle-of-the-zerof2-routine">
<span id="r5-03-08-4-2"></span><h3><span class="section-number">13.2.4.2. </span>Solution of the scalar equation: principle of the <code class="docutils literal notranslate"><span class="pre">ZEROF2</span></code> routine<a class="headerlink" href="#solution-of-the-scalar-equation-principle-of-the-zerof2-routine" title="Permalink to this headline">¶</a></h3>
<p>It can be shown that, if the conditions required in <a class="reference internal" href="r5.03.09.html#r5-03-09-3"><span class="std std-numref">Section 13.3.3</span></a> on the characteristics of materials are
satisfied, the function <span class="math notranslate nohighlight">\(f\)</span> is strictly increasing and the equation <span class="math notranslate nohighlight">\(f(x) = 0\)</span> admits a unique solution.</p>
<p>If <span class="math notranslate nohighlight">\(\sigma_{\text{eq}}^e = 0\)</span>, then the solution is <span class="math notranslate nohighlight">\(x = 0\)</span>. Otherwise, we have:
<span class="math notranslate nohighlight">\(f(0) = -\sigma_{\text{eq}}^e &lt; 0\)</span></p>
<p>The problem therefore consists in finding, for any function <span class="math notranslate nohighlight">\(f\)</span>, the solution of the equation
<span class="math notranslate nohighlight">\(f(x) = 0\)</span> knowing that this solution exists, that <span class="math notranslate nohighlight">\(f(0) &lt; 0\)</span> and that <span class="math notranslate nohighlight">\(f\)</span> is strictly increasing.</p>
<p>The algorithm adopted in <code class="docutils literal notranslate"><span class="pre">ZEROF2</span></code> is as follows:</p>
<ul>
<li><p>we start with <span class="math notranslate nohighlight">\(a_0\)</span> = 0 and <span class="math notranslate nohighlight">\(b_0 = x_{ap}\)</span> where <span class="math notranslate nohighlight">\(x_{ap}\)</span> is an approximation of the solution.
If necessary (i.e., if <span class="math notranslate nohighlight">\(f(b_0) &lt; 0\)</span>), we use the secant method</p>
<div class="math notranslate nohighlight">
\[z_n = \frac{a_n f(b_n) - b_n f(a_n)}{f(b_n) - f(a_n)} \quad
\text{then} \quad  a_{n+1} = b_n \quad \text{and} \quad  b_{n+1} = z_n\]</div>
<p>in one or more iterations for the case where <span class="math notranslate nohighlight">\(f(a) &lt; 0\)</span> and <span class="math notranslate nohighlight">\(f(b) &gt; 0\)</span> as seen in the
figure below :</p>
<div class="figure align-center">
<a class="reference internal image-reference" href="../../_images/fig1_r5.03.08.png"><img alt="../../_images/fig1_r5.03.08.png" src="../../_images/fig1_r5.03.08.png" style="height: 300px;" /></a>
</div>
<p>In the case of the figure above, this step was completed in one iteration: <span class="math notranslate nohighlight">\(a_1 = b_0\)</span> and
<span class="math notranslate nohighlight">\(f(b_1) &gt; 0\)</span>.</p>
</li>
<li><p>we calculate <span class="math notranslate nohighlight">\(N_d = \text{round}(\sqrt{N_{\text{max}}})\)</span> where <span class="math notranslate nohighlight">\(N_{\text{max}}\)</span> is the maximum number
of iterations allowed. We then solve the equation by the secant method using the bisection method whenever <span class="math notranslate nohighlight">\(n\)</span>
is a multiple of <span class="math notranslate nohighlight">\(N_d\)</span> :</p>
<blockquote>
<div><ul>
<li><p>Tag 1:</p>
<blockquote>
<div><ul>
<li><p>If <span class="math notranslate nohighlight">\(N_d\)</span> is a whole number factor of <span class="math notranslate nohighlight">\(n\)</span>:</p>
<div class="math notranslate nohighlight">
\[z n = \frac{a_n + b_n}{2}\]</div>
</li>
<li><p>else</p>
<div class="math notranslate nohighlight">
\[z_n = \frac{a_n f(b_n) - b_n f(a_n)}{f(b_n) - f(a_n)} \quad\]</div>
</li>
<li><p>endif</p></li>
<li><p><span class="math notranslate nohighlight">\(n = n + 1\)</span></p></li>
<li><p>if <span class="math notranslate nohighlight">\(∣f(z)∣ &gt; \epsilon\)</span></p>
<ul>
<li><p>if <span class="math notranslate nohighlight">\(f(z) &lt; 0\)</span></p>
<p><span class="math notranslate nohighlight">\(a_{n+1} = z_n \quad b_{n+1} = b_n\)</span></p>
</li>
<li><p>else</p>
<p><span class="math notranslate nohighlight">\(a_{n+1} = a_n \quad b_{n+1} = z_n\)</span></p>
</li>
<li><p>endif</p></li>
<li><p>go to Tag 1</p></li>
</ul>
</li>
<li><p>else</p>
<ul class="simple">
<li><p>The solution is: <span class="math notranslate nohighlight">\(x = z_n \rightarrow \quad \text{END}\)</span></p></li>
</ul>
</li>
<li><p>endif</p></li>
</ul>
</div></blockquote>
</li>
</ul>
</div></blockquote>
</li>
</ul>
<p>This second part of the algorithm makes it possible to process problems where <span class="math notranslate nohighlight">\(f\)</span> is strongly nonlinear in
a reasonable number of iterations, where the secant method would have converged too slowly. These cases of strong
non-linearity are encountered in particular with the LEMAITRE model, for large values of <span class="math notranslate nohighlight">\(n/m\)</span>.</p>
</div>
<div class="section" id="calculation-of-the-stress-at-the-end-of-the-current-time-step">
<span id="r5-03-08-4-3"></span><h3><span class="section-number">13.2.4.3. </span>Calculation of the stress at the end of the current time step<a class="headerlink" href="#calculation-of-the-stress-at-the-end-of-the-current-time-step" title="Permalink to this headline">¶</a></h3>
<p>According to <a class="reference internal" href="#equation-eq-r5-03-08-4-1-3">(13.2.4)</a>, if <span class="math notranslate nohighlight">\(x\)</span> is the solution of the scalar equation, by posing:</p>
<div class="math notranslate nohighlight">
\[b(x, \sigma_{\text{eq}}^e) = \frac{1}{1+3\mu \Delta t \frac{g(x, \lambda^{-} + \frac{1}{3\mu}(\sigma_{\text{eq}}^e - x), T)}{x}} = \frac{x}{\sigma_{\text{eq}}^e}\]</div>
<p>we have :</p>
<div class="math notranslate nohighlight" id="equation-eq-r5-03-08-4-3-1">
<span class="eqno">(13.2.6)<a class="headerlink" href="#equation-eq-r5-03-08-4-3-1" title="Permalink to this equation">¶</a></span>\[\tilde{\boldsymbol{\sigma}} = b(x, \sigma_{\text{eq}}^e) \tilde{\boldsymbol{\sigma}}^e\]</div>
<p>In the case where <span class="math notranslate nohighlight">\(\sigma_{\text{eq}}^e = 0\)</span>, which is equivalent according to the scalar equation to
<span class="math notranslate nohighlight">\(x = 0\)</span>, we extend <span class="math notranslate nohighlight">\(b\)</span> by continuity. For that, we set</p>
<div class="math notranslate nohighlight">
\[y(x) = \lambda^{-} + \frac{1}{3\mu} (\sigma_{\text{eq}}^e- x)\]</div>
<p>and <span class="math notranslate nohighlight">\(G(x) = g(x, y(x), T)\)</span>.</p>
<p>The derivative of <span class="math notranslate nohighlight">\(G\)</span> is expressed as a function of the partial derivatives of <span class="math notranslate nohighlight">\(g\)</span> at the point
<span class="math notranslate nohighlight">\((x, y(x), T)\)</span> :</p>
<div class="math notranslate nohighlight">
\[G'(x) = \frac{\partial g}{\partial x} (x, y(x), T) - \frac{1}{3\mu} \frac{\partial g}{\partial y} (x, y(x), T)\]</div>
<p>The continuation of <span class="math notranslate nohighlight">\(b\)</span> by continuity then gives:</p>
<div class="math notranslate nohighlight">
\[b(0, 0) = \frac{1}{1 + 3\mu \Delta t G'(0)}\]</div>
<p>and we have, always in the case where <span class="math notranslate nohighlight">\(\sigma _{\text{eq}}^e = 0\)</span>, <span class="math notranslate nohighlight">\(\tilde{\boldsymbol{\sigma}} = 0\)</span>.</p>
<p>Once we have calculated <span class="math notranslate nohighlight">\(\tilde{\boldsymbol{\sigma}}\)</span>, we obtain <span class="math notranslate nohighlight">\(\boldsymbol{\sigma}\)</span> by the relation
(<span class="math notranslate nohighlight">\(K\)</span> is here assumed to be constant):</p>
<div class="math notranslate nohighlight" id="equation-eq-r5-03-08-4-3-2">
<span class="eqno">(13.2.7)<a class="headerlink" href="#equation-eq-r5-03-08-4-3-2" title="Permalink to this equation">¶</a></span>\[\boldsymbol{\sigma} = \boldsymbol{\sigma}^{-} + \Delta\boldsymbol{\sigma} =
   \tilde{\boldsymbol{\sigma}} + \left(\frac{1}{3} \text{Tr}(\boldsymbol{\sigma}^{-}) +
      K \text{Tr}(\Delta \boldsymbol{\varepsilon}) \right) \mathbf{I}_3\]</div>
</div>
<div class="section" id="semi-implicit-scheme">
<span id="r5-03-08-4-4"></span><h3><span class="section-number">13.2.4.4. </span>Semi-implicit scheme<a class="headerlink" href="#semi-implicit-scheme" title="Permalink to this headline">¶</a></h3>
<p>In the case where <span class="math notranslate nohighlight">\(g\)</span> does not depend on <span class="math notranslate nohighlight">\(\lambda\)</span>, the implicit numerical scheme <a class="reference internal" href="#equation-eq-r5-03-08-4-1-2">(13.2.3)</a>
can be used for the computation of stress at the end of the time step for a given
<span class="math notranslate nohighlight">\(\Delta \boldsymbol{\varepsilon}_v\)</span>.
If the stress varies significantly over time (see <a class="footnote-reference brackets" href="#bib2" id="id3">2</a>), the implicit scheme can lead to large errors.</p>
<p>To remedy that and to improve the solution, we discretize the flow rule in a semi-implicit manner:</p>
<div class="math notranslate nohighlight" id="equation-eq-r5-03-08-4-4-1">
<span class="eqno">(13.2.8)<a class="headerlink" href="#equation-eq-r5-03-08-4-4-1" title="Permalink to this equation">¶</a></span>\[\frac{\Delta \boldsymbol{\varepsilon}_v}{\Delta t} =
  \frac{3}{2} g\left(\left(\boldsymbol{\sigma}^{-} + \frac{\Delta \boldsymbol{\sigma}}{2} \right)_{\text{eq}},
                     \lambda^{-} + \frac{(\Delta \boldsymbol{\varepsilon}_v)_{\text{eq}}}{2},
                     T^{-} + \frac{\Delta T}{2} \right)
    \frac{\tilde{\boldsymbol{\sigma}}^{-} + \frac{\Delta \tilde{\boldsymbol{\sigma}}}{2}}
         {\left(\boldsymbol{\sigma}^{-} + \frac{\Delta \boldsymbol{\sigma}}{2}\right)_{\text{eq}}}\]</div>
<p>An economical way of transforming the fully implicit formulation <a class="reference internal" href="#equation-eq-r5-03-08-4-1-2">(13.2.3)</a>, is  to divide each member
of equation [eq:<cite>eq_r5.03.08.4.4-1</cite> by 2:</p>
<div class="math notranslate nohighlight">
\[\frac{\Delta \boldsymbol{\varepsilon}_v/2}{\Delta t} =
  \frac{1}{2}
    \left[\frac{3}{2} g\left(\left(\boldsymbol{\sigma}^{-} + \frac{\Delta \boldsymbol{\sigma}}{2} \right)_{\text{eq}},
                     \lambda^{-} + \frac{(\Delta \boldsymbol{\varepsilon}_v)_{\text{eq}}}{2},
                     T^{-} + \frac{\Delta T}{2} \right)
    \frac{\tilde{\boldsymbol{\sigma}}^{-} + \frac{\Delta \tilde{\boldsymbol{\sigma}}}{2}}
         {\left(\boldsymbol{\sigma}^{-} + \frac{\Delta \boldsymbol{\sigma}}{2}\right)_{\text{eq}}}\right]\]</div>
<p>and to do the same thing with <a class="reference internal" href="#equation-eq-r5-03-08-4-1-1">(13.2.2)</a>]:</p>
<div class="math notranslate nohighlight">
\[\frac{\Delta \tilde{\boldsymbol{\sigma}}}{2} = 2\mu \left(\frac{\Delta\tilde{\boldsymbol{\varepsilon}}}{2} -
    \frac{\Delta\boldsymbol{\varepsilon}_v }{2}\right)\]</div>
<p>Note that this system has the same form as that of <a class="reference internal" href="#equation-eq-r5-03-08-4-1-1">(13.2.2)</a> and <a class="reference internal" href="#equation-eq-r5-03-08-4-1-2">(13.2.3)</a>, the data
being <span class="math notranslate nohighlight">\(\Delta \boldsymbol{\varepsilon}/2\)</span> instead of <span class="math notranslate nohighlight">\(\Delta \boldsymbol{\varepsilon}\)</span>, the unknowns
being respectively <span class="math notranslate nohighlight">\(\Delta\boldsymbol{\sigma}/2\)</span> and <span class="math notranslate nohighlight">\(\Delta \boldsymbol{\varepsilon}_v/2\)</span> instead of
<span class="math notranslate nohighlight">\(\Delta \boldsymbol{\sigma}\)</span> and <span class="math notranslate nohighlight">\(\Delta \boldsymbol{\varepsilon}_v\)</span> and the function <span class="math notranslate nohighlight">\(g/2\)</span>
replacing function <span class="math notranslate nohighlight">\(g\)</span>.</p>
<p>One can thus use the solution process from <a class="reference internal" href="#r5-03-08-4-1"><span class="std std-numref">Section 13.2.4.1</span></a> with <a class="reference internal" href="#r5-03-08-4-3"><span class="std std-numref">Section 13.2.4.3</span></a> as well as the
corresponding algorithm by introducing <span class="math notranslate nohighlight">\(\Delta \boldsymbol{\varepsilon}/2\)</span> and dividing the function <span class="math notranslate nohighlight">\(g\)</span>
by 2. It then remains to multiply the results <span class="math notranslate nohighlight">\(\Delta\boldsymbol{\sigma}/2\)</span> and
<span class="math notranslate nohighlight">\(\Delta \boldsymbol{\varepsilon}_v/2\)</span> by 2 to obtain the stress and viscous strain increments calculated by
the semi-implicit scheme (the <span class="math notranslate nohighlight">\(\Delta \boldsymbol{\sigma}\)</span> and the
<span class="math notranslate nohighlight">\(\Delta \boldsymbol{\varepsilon}_v\)</span> of equation <a class="reference internal" href="#equation-eq-r5-03-08-4-4-1">(13.2.8)</a>).</p>
<p>Note that the computation of the tangent operator is not affected by this modification of the numerical scheme.
Indeed, we obviously have:</p>
<div class="math notranslate nohighlight">
\[\frac{\partial\Delta\boldsymbol{\sigma}}{\partial\Delta\boldsymbol{\varepsilon}} =
  \frac{\partial(\Delta \boldsymbol{\sigma}/2)}{\partial(\Delta\boldsymbol{\varepsilon}/2)}\]</div>
</div>
<div class="section" id="taking-into-account-of-the-variation-of-the-elastic-coefficients-with-temperature">
<span id="r5-03-08-4-5"></span><h3><span class="section-number">13.2.4.5. </span>Taking into account of the variation of the elastic coefficients with temperature<a class="headerlink" href="#taking-into-account-of-the-variation-of-the-elastic-coefficients-with-temperature" title="Permalink to this headline">¶</a></h3>
<p>If <span class="math notranslate nohighlight">\(\mathbb{A}\)</span> is the elasticity tensor, we have:</p>
<div class="math notranslate nohighlight">
\[\Delta\boldsymbol{\varepsilon} = \Delta\boldsymbol{\varepsilon}_v + \Delta (\mathbb{A}^{-1} \boldsymbol{\sigma})\]</div>
<p>with :</p>
<div class="math notranslate nohighlight">
\[\Delta (\mathbb{A}^{-1} \boldsymbol{\sigma}) = \mathbb{A}^{-1}(T^{-} + \Delta T)
   (\boldsymbol{\sigma}^{-} + \Delta \boldsymbol{\sigma}) - \mathbb{A}^{-1}(T^{-}) \boldsymbol{\sigma}^{-}\]</div>
<p>This results in the equations of <a class="reference internal" href="#r5-03-08-4-4"><span class="std std-numref">Section 13.2.4.4</span></a> by:</p>
<div class="math notranslate nohighlight">
\[\begin{split}&amp; 2\mu \left(\frac{\Delta\tilde{\boldsymbol{\varepsilon}}}{2}\right) -
\left(\tilde{\boldsymbol{\sigma}}^{-} + \frac{\Delta\tilde{\boldsymbol{\sigma}}}{2}\right) =
3\mu\Delta t\,\, \\
&amp; \quad \quad
\frac{g\left(\left(\boldsymbol{\sigma}^{-} + \frac{\Delta \boldsymbol{\sigma}}{2}\right)_{\text{eq}},
       \lambda^{-} + \frac{(\Delta\boldsymbol{\varepsilon}_v)_{\text{eq}}}{2},
       T^{-} + \frac{\Delta T}{2}\right)}{2}
\frac{\left(\tilde{\boldsymbol{\sigma}}^{-} + \frac{\Delta \boldsymbol{\sigma}}{2}\right)}
     {\left(\boldsymbol{\sigma}^{-} + \frac{\Delta \boldsymbol{\sigma}}{2}\right)_{\text{eq}}} - \\
&amp; \quad\quad\quad \tilde{\boldsymbol{\sigma}}^{-} \left(\frac{2\mu^{-} + 2\mu}{4\mu^{-}}\right)\end{split}\]</div>
<p>By setting :</p>
<div class="math notranslate nohighlight">
\[\tilde{\boldsymbol{\sigma}}^e = \left(\frac{2\mu^{-} + 2\mu}{4\mu^{-}}\right)
    \tilde{\boldsymbol{\sigma}}^{-} + 2\mu \left(\frac{\Delta \tilde{\boldsymbol{\varepsilon}}}{2}\right)\]</div>
<p>and</p>
<div class="math notranslate nohighlight">
\[\text{Tr}(\boldsymbol{\sigma}^e) = \left(\frac{3K^{-} +3K}{6K^{-}}\right) \text{Tr}(\boldsymbol{\sigma}^{-}) +
  3K \text{Tr}\left(\frac{\Delta\boldsymbol{\varepsilon}}{2}\right)\]</div>
<p>we can reproduce the preceding case <a class="reference internal" href="#r5-03-08-4-4"><span class="std std-numref">Section 13.2.4.4</span></a>.</p>
</div>
</div>
<div class="section" id="calculation-of-the-tangent-operator">
<span id="r5-03-08-5"></span><h2><span class="section-number">13.2.5. </span>Calculation of the tangent operator<a class="headerlink" href="#calculation-of-the-tangent-operator" title="Permalink to this headline">¶</a></h2>
<p>In the case where <span class="math notranslate nohighlight">\(\sigma_{\text{eq}}^e = 0\)</span> and <span class="math notranslate nohighlight">\(x = 0\)</span>, one takes the elasticity tensor as the
tangent operator.</p>
<p>If not, one obtains this operator by differentiating equation <a class="reference internal" href="#equation-eq-r5-03-08-4-3-1">(13.2.6)</a> with respect to
<span class="math notranslate nohighlight">\(\Delta\boldsymbol{\varepsilon}\)</span> :</p>
<div class="math notranslate nohighlight">
\[\frac{\partial \tilde{\boldsymbol{\sigma}}}{\partial\boldsymbol{\varepsilon}} =
\frac{\partial\Delta\tilde{\boldsymbol{\sigma}}}{\partial\Delta\boldsymbol{\varepsilon}} =
\frac{\partial b(x, \sigma_{\text{eq}}^e)}{\partial\Delta\boldsymbol{\varepsilon}} \tilde{\boldsymbol{\sigma}}^e
+ b(x, \sigma_{\text{eq}}^e) \frac{\partial\tilde{\boldsymbol{\sigma}}^e}{\partial\Delta\boldsymbol{\varepsilon}}\]</div>
<p>then by also differentiating <a class="reference internal" href="#equation-eq-r5-03-08-4-3-2">(13.2.7)</a> with respect to <span class="math notranslate nohighlight">\(\Delta\boldsymbol{\varepsilon}\)</span> :</p>
<div class="math notranslate nohighlight">
\[\frac{\partial\Delta\boldsymbol{\sigma}}{\partial\Delta\boldsymbol{\varepsilon}} =
\frac{\partial\Delta\tilde{\boldsymbol{\sigma}}}{\partial\Delta\boldsymbol{\varepsilon}} +
K \mathbf{I}_3 \frac{\partial \text{Tr}(\Delta\boldsymbol{\varepsilon})}{\partial\Delta\boldsymbol{\varepsilon}} =
\frac{\partial\Delta\tilde{\boldsymbol{\sigma}}}{\partial\Delta\boldsymbol{\varepsilon}} +
K \mathbf{I}_3^{'} \mathbf{I}_3\]</div>
<p>It will be noted that, in these equations, tensors of order 2 and order 4 are represented by vectors and matrices,
respectively. <span class="math notranslate nohighlight">\(\mathbf{I}_3\)</span> is here a tensor of order 2, expressed as a vector:t</p>
<div class="math notranslate nohighlight">
\[\mathbf{I}_3 = \begin{bmatrix} 1 &amp; 1 &amp; 1 &amp; 0 &amp; 0 &amp; 0 \end{bmatrix}^T\]</div>
<p>We also have:</p>
<div class="math notranslate nohighlight">
\[\frac{\partial b(x, \sigma_{\text{eq}}^e)}{\partial\Delta\boldsymbol{\varepsilon}} =
\frac{\partial b}{\partial x} \frac{\partial x}{\partial\Delta\boldsymbol{\varepsilon}} +
\frac{\partial b}{\partial\sigma_{\text{eq}}^e} \frac{\partial\sigma_{\text{eq}}^e}{\partial\Delta\boldsymbol{\varepsilon}}\]</div>
<p>It is therefore necessary to calculate <span class="math notranslate nohighlight">\(\frac{\partial x}{\partial\Delta\boldsymbol{\varepsilon}}\)</span>. For
that, one implicitly derives the scalar equation with respect to <span class="math notranslate nohighlight">\(\Delta\boldsymbol{\varepsilon}\)</span>.</p>
<p>For simplicity, we will omit hereafter in writing <span class="math notranslate nohighlight">\(g\)</span> and its derivatives, the parameter <span class="math notranslate nohighlight">\(T\)</span>.</p>
<p>We then have:</p>
<div class="math notranslate nohighlight">
\[[3\mu\Delta t G^{'}(x) + 1] \frac{\partial x}{\partial\Delta\boldsymbol{\varepsilon}} +
  \Delta t \frac{\partial g}{\partial y}(x,y) \frac{\partial\sigma_{\text{eq}}^e}{\partial\Delta\boldsymbol{\varepsilon}} =
\frac{\partial\sigma_{\text{eq}}^e}{\partial\Delta\boldsymbol{\varepsilon}}\]</div>
<p>From where :</p>
<div class="math notranslate nohighlight">
\[\begin{split}\frac{\partial x}{\partial\Delta\boldsymbol{\varepsilon}} &amp; =
  \frac{1 - \Delta t \frac{\partial g}{\partial y}}{1+3\mu\Delta t G^{'}(x)}
     \frac{\partial\sigma_{\text{eq}}^e}{\partial\Delta\boldsymbol{\varepsilon}} \\
&amp; =
  \frac{1 - \Delta t \frac{\partial g}{\partial y}}{1+3\mu\Delta t G^{'}(x)}
     \frac{3\mu}{\sigma_{\text{eq}}^e}\tilde{\boldsymbol{\sigma}}^e\end{split}\]</div>
<p>with the expression for <span class="math notranslate nohighlight">\(G^{'}(x)\)</span> obtained with <a class="reference internal" href="#r5-03-08-4-3"><span class="std std-numref">Section 13.2.4.3</span></a>.</p>
<p>We finally obtain the following expression of the tangent operator:</p>
<div class="math notranslate nohighlight">
\[\frac{\partial\Delta\boldsymbol{\sigma}}{\partial\Delta\boldsymbol{\varepsilon}} =
  K \mathbf{I}_3^T \mathbf{I}_3 + 2\mu [ \gamma (\tilde{\boldsymbol{\sigma}}^e)^T \tilde{\boldsymbol{\sigma}}^e +
  b(x,\sigma_{\text{eq}}^e) \mathbb{A}]\]</div>
<p>with</p>
<div class="math notranslate nohighlight">
\[\mathbb{A} = \frac{\partial\Delta\tilde{\boldsymbol{\varepsilon}}}{\partial\Delta\boldsymbol{\varepsilon}} =
  \mathbf{J}_6 - \frac{1}{3} \mathbf{I}_3^T \mathbf{I}_3\]</div>
<p>where <span class="math notranslate nohighlight">\(\mathbf{J}_6\)</span> is the rank 6 identity matrix,</p>
<div class="math notranslate nohighlight">
\[\gamma = \frac{3}{2 (\sigma_{\text{eq}}^e)^3}
  \left[ \sigma_{\text{eq}}^e \frac{1 - \Delta t\frac{\partial g}{\partial y}}{1+3\mu\Delta t G^{'}(x)}
         - x \right]\]</div>
<div class="admonition-remark admonition">
<p class="admonition-title">Remark</p>
<p>In the case of the <span class="blue">VISC_IRRA_LOG</span> model, one easily checks that:</p>
<div class="math notranslate nohighlight">
\[\begin{split}&amp; G'(x) = \frac{1}{f_1' g_1+ f_2' g_2}
        \left[
  g_1 g_1' ( (f_1')^2 - f_1 f_1'' ) + g_2 g_2' ( (f_2')^2 - f_2 f_2'' ) + \right.\\
&amp; \qquad \left.  g_1 g_2' ( f_1' f_2' - f_1'' f_2 ) + g_2 g_1' ( f_1' f_2' - f_1 f_2'' ) -
  \frac{1}{3m} ( f_1'' g_1 + f_2'' g_2 ) \right] \\
&amp; \frac{\partial g}{\partial\lambda} (x, y, T) =
  \frac{f_1'' g_1+ f_2'' g_2}{f_1' g_1 + f_2' g_2}\end{split}\]</div>
<p>where <span class="math notranslate nohighlight">\(f_1, f_1', f_1'', f_2, f_2', f_2''\)</span> denote the values of <span class="math notranslate nohighlight">\(f_1\)</span> and <span class="math notranslate nohighlight">\(f_2\)</span> and
their derivatives at point <span class="math notranslate nohighlight">\(t(x, y, T)\)</span> and where <span class="math notranslate nohighlight">\(g_1, g_1', g_2, g_2'\)</span> denote the values
of <span class="math notranslate nohighlight">\(g_1\)</span> and <span class="math notranslate nohighlight">\(g_2\)</span> and their derivatives with respect to <span class="math notranslate nohighlight">\(\sigma\)</span> at the point
<span class="math notranslate nohighlight">\((x, T)\)</span> (see <a class="footnote-reference brackets" href="#bib1" id="id4">1</a>)</p>
</div>
</div>
<div class="section" id="bibliography">
<span id="r5-03-08-6"></span><h2><span class="section-number">13.2.6. </span>Bibliography<a class="headerlink" href="#bibliography" title="Permalink to this headline">¶</a></h2>
<dl class="footnote brackets">
<dt class="label" id="bib1"><span class="brackets">1</span><span class="fn-backref">(<a href="#id2">1</a>,<a href="#id4">2</a>)</span></dt>
<dd><p>de BONNIERES P.: Writing in generalized standard form of the viscoplastic constitutive laws
for Zircaloy, note EDF-DER HI-71/7940-Index A, 1992</p>
</dd>
<dt class="label" id="bib2"><span class="brackets">2</span><span class="fn-backref">(<a href="#id1">1</a>,<a href="#id3">2</a>)</span></dt>
<dd><p>de BONNIERES P., ZIDI M.: Introduction of viscoplasticity in the thermomechanical modulus
of Cyrano3: principle, description and validation, EDF-DER HI- note71/8334, 1993.</p>
</dd>
</dl>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<form action="../../search.html" method="get">
  <input class='c-searchbox' type="text" name="q" placeholder="Search" />
  <input type="hidden" name="check_keywords" value="yes" />
  <input type="hidden" name="area" value="default" />
</form><div>
   <h3>Quick search</h3>
   <script async src="https://cse.google.com/cse.js?cx=1913d02e421931d61"></script>
   <div class="gcse-search"></div>
</div><h3>On this page</h3>
<ul>
<li><a class="reference internal" href="#">13.2. <strong>[R5.03.08]</strong> : Integration of nonlinear viscoplastic material models in <code class="docutils literal notranslate"><span class="pre">STAT_NON_LINE</span></code></a><ul>
<li><a class="reference internal" href="#introduction">13.2.1. Introduction</a></li>
<li><a class="reference internal" href="#basic-principle-and-assumptions">13.2.2. Basic principle and assumptions</a></li>
<li><a class="reference internal" href="#nature-of-the-function-g-for-each-of-the-models">13.2.3. Nature of the function <span class="math notranslate nohighlight">\(g\)</span> for each of the models</a><ul>
<li><a class="reference internal" href="#lemaitre-model">13.2.3.1. <span class="blue">LEMAITRE</span> model</a></li>
<li><a class="reference internal" href="#fluence-dependent-lemaitre-model-lemaitre-irra">13.2.3.2. Fluence-dependent <span class="blue">LEMAITRE</span> model (<span class="blue">LEMAITRE_IRRA</span>)</a><ul>
<li><a class="reference internal" href="#model-formulation">13.2.3.2.1. Model formulation</a></li>
<li><a class="reference internal" href="#treatment-of-fluence-dependence">13.2.3.2.2. Treatment of fluence-dependence</a></li>
</ul>
</li>
<li><a class="reference internal" href="#lema-seuil-model">13.2.3.3. <span class="blue">LEMA_SEUIL</span> model</a></li>
<li><a class="reference internal" href="#visc-irra-log-model">13.2.3.4. <span class="blue">VISC_IRRA_LOG</span> model</a></li>
</ul>
</li>
<li><a class="reference internal" href="#integration-of-the-constitutive-relation">13.2.4. Integration of the constitutive relation</a><ul>
<li><a class="reference internal" href="#establishment-of-the-scalar-equation-for-the-implicit-scheme-and-with-constant-elastic-coefficients">13.2.4.1. Establishment of the scalar equation for the implicit scheme and with constant elastic coefficients</a></li>
<li><a class="reference internal" href="#solution-of-the-scalar-equation-principle-of-the-zerof2-routine">13.2.4.2. Solution of the scalar equation: principle of the <code class="docutils literal notranslate"><span class="pre">ZEROF2</span></code> routine</a></li>
<li><a class="reference internal" href="#calculation-of-the-stress-at-the-end-of-the-current-time-step">13.2.4.3. Calculation of the stress at the end of the current time step</a></li>
<li><a class="reference internal" href="#semi-implicit-scheme">13.2.4.4. Semi-implicit scheme</a></li>
<li><a class="reference internal" href="#taking-into-account-of-the-variation-of-the-elastic-coefficients-with-temperature">13.2.4.5. Taking into account of the variation of the elastic coefficients with temperature</a></li>
</ul>
</li>
<li><a class="reference internal" href="#calculation-of-the-tangent-operator">13.2.5. Calculation of the tangent operator</a></li>
<li><a class="reference internal" href="#bibliography">13.2.6. Bibliography</a></li>
</ul>
</li>
</ul>


        </div>
      </div>
      <div class="clearer"></div>
    </div>
<footer class="footer">
  <p class="pull-right">
    <a href="../../_sources/docs/reference/r5.03.08.rst.txt"
       rel="nofollow">Page Source</a> &nbsp;
    <a href="#">Back to Top</a></p>
  <p>
  </p>
  <p>
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 3.5.1. Page design is based on <a href="https://project.lsst.org">LSST</a> created modifications of Astropy's bootstrap-astropy theme in <a href="https://github.com/astropy/astropy-helpers">astropy-helpers</a>. <br />
  </p>
  <p>
    &copy; Copyright 2021, Biswajit Banerjee.  Original version &copy; Copyright 2019 EDF R&amp;D - Licensed under the terms of the GNU FDL (http://www.gnu.org/copyleft/fdl.html).<br/>
  </p>
</footer>
  </body>
</html>